unit TesteGL2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, OGLPanel, OpenGL, StdCtrls;

type
  TForm1 = class(TForm)
    PainelGL: TOGLPanel;
    Button1: TButton;
    procedure PainelGLAfterLoad(Sender: TObject);
    procedure PainelGLOGLPaint;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var

  flag: integer;

{$R *.DFM}

procedure TForm1.PainelGLAfterLoad(Sender: TObject);
begin
// Colocar aqui sempre estes comandos de inicializao do OpenGL
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(-50,50,-50,50,-100,100);

end;

procedure TForm1.PainelGLOGLPaint;
begin
// Limpa a janela
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); // Colocar isto sempre
                                                        // no incio desta rotina


   if Flag = 1
   then begin
          glLoadIdentity(); // reseta a janela de seleo
          glOrtho(-60,60,-60,60,-100,100); // redefine a janela de seleo
        end
   else begin
          glLoadIdentity(); // reseta a janela de seleo
          glOrtho(-50,50,-50,50,-100,100); // redefine a janela de seleo
        end;


// Exibe os objetos
   glColor3f(255,0,0);
   glBegin(GL_LINES);
      glVertex2f(-40,40);
      glVertex2f(0,0);
      glVertex2f(0,40);
      glVertex2f(40,0);
   glEnd;

   PainelGL.Swap;  // fora a exibio das imagens

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if Flag = 1
   then Flag :=0
   else Flag := 1;
   PainelGL.repaint();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  flag := 0;
end;

end.
